import{s as ss,n as ls,o as ps}from"../chunks/scheduler.85c25b89.js";import{S as ds,i as cs,g as a,s as o,r as d,A as gs,h as r,f as i,c as n,j as l,u as c,x as m,k as v,y as t,a as p,v as g,d as u,t as f,w as h}from"../chunks/index.c9837788.js";import{D as b}from"../chunks/Docstring.5c1d567f.js";import{H as K,E as us}from"../chunks/EditOnGithub.b65eee75.js";function fs(bi){let Z,vr,rr,br,ve,_r,be,_i="This page contains the API reference documentation for learning rate optimizers included in <code>timm</code>.",xr,_e,yr,xe,$r,_,ye,yo,Lt,xi="Create an optimizer instance via timm registry.",$o,Tt,yi=`Creates and configures an optimizer with appropriate parameter groups and settings.
Supports automatic parameter group creation for weight decay and layer-wise learning
rates, as well as custom parameter grouping.`,wo,zt,$i="Examples:",Co,or,nr,$e,we,Ao,Dt,wi="optimizer = create_optimizer_v2(model, ‘adamw’, lr=1e-3)",Lo,ir,mr,Ce,Ae,To,Mt,Ci=`optimizer = create_optimizer_v2(
…     model, ‘sgd’, lr=0.1, momentum=0.9, weight_decay=1e-4
… )`,zo,sr,lr,Le,Te,Do,Pt,Ai=`optimizer = create_optimizer_v2(
…     model, ‘adam’, lr=1e-3, layer_decay=0.7
… )`,Mo,pr,dr,ze,De,Po,qt,Li=`def group_fn(model):
…     return [
…         {‘params’: model.backbone.parameters(), ‘lr’: 1e-4},
…         {‘params’: model.head.parameters(), ‘lr’: 1e-3}
…     ]
optimizer = create_optimizer_v2(
…     model, ‘sgd’, param_group_fn=group_fn
… )`,qo,kt,Ti=`Note:
Parameter group handling precedence:`,ko,Et,zi="<li>If param_group_fn is provided, it will be used exclusively</li> <li>If layer_decay is provided, layer-wise groups will be created</li> <li>If weight_decay &gt; 0 and filter_bias_and_bn is True, weight decay groups will be created</li> <li>Otherwise, all parameters will be in a single group</li>",wr,x,Me,Eo,Nt,Di="List available optimizer names, optionally filtered.",No,Ot,Mi=`List all registered optimizers, with optional filtering using wildcard patterns.
Optimizers can be filtered using include and exclude patterns, and can optionally
return descriptions with each optimizer name.`,Oo,It,Pi="Examples:",Io,Ft,qi=`<blockquote><blockquote><p>list_optimizers()
[‘adam’, ‘adamw’, ‘sgd’, …]</p></blockquote></blockquote>`,Fo,Ht,ki=`<blockquote><blockquote><p>list_optimizers([‘la<em>’, ‘nla</em>’])  # List lamb &amp; lars
[‘lamb’, ‘lambc’, ‘larc’, ‘lars’, ‘nlarc’, ‘nlars’]</p></blockquote></blockquote>`,Ho,Bt,Ei=`<blockquote><blockquote><p>list_optimizers(’<em>adam</em>’, exclude_filters=[‘bnb<em>’, ‘fused</em>’])  # Exclude bnb &amp; apex adam optimizers
[‘adam’, ‘adamax’, ‘adamp’, ‘adamw’, ‘nadam’, ‘nadamw’, ‘radam’]</p></blockquote></blockquote>`,Bo,Rt,Ni=`<blockquote><blockquote><p>list_optimizers(with_description=True)  # Get descriptions
[(‘adabelief’, ‘Adapts learning rate based on gradient prediction error’),
(‘adadelta’, ‘torch.optim Adadelta, Adapts learning rates based on running windows of gradients’),
(‘adafactor’, ‘Memory-efficient implementation of Adam with factored gradients’),
…]</p></blockquote></blockquote>`,Cr,C,Pe,Ro,Gt,Oi="Get optimizer class by name with option to bind default arguments.",Go,St,Ii=`Retrieves the optimizer class or a partial function with default arguments bound.
This allows direct instantiation of optimizers with their default configurations
without going through the full factory.`,So,Vt,Fi="Examples:",Vo,cr,gr,qe,ke,Wo,Wt,Hi=`SGD = get_optimizer_class(‘sgd’)  # nesterov=True bound
opt = SGD(model.parameters(), lr=0.1, momentum=0.9)`,Uo,ur,fr,Ee,Ne,Qo,Ut,Bi=`SGD = get_optimizer_class(‘sgd’)
opt = SGD(model.parameters(), lr=1e-3, momentum=0.9)`,Ar,Oe,Lr,A,Ie,jo,Qt,Ri="Implements AdaBelief algorithm. Modified from Adam in PyTorch",Ko,jt,Gi="reference: AdaBelief Optimizer, adapting stepsizes by the belief in observed gradients, NeurIPS 2020",Zo,Kt,Si=`For a complete table of recommended hyperparameters, see <a href="https://github.com/juntang-zhuang/Adabelief-Optimizer&#39;" rel="nofollow">https://github.com/juntang-zhuang/Adabelief-Optimizer’</a>
For example train/args for EfficientNet see these gists`,Xo,Zt,Vi='<li>link to train_scipt: <a href="https://gist.github.com/juntang-zhuang/0a501dd51c02278d952cf159bc233037" rel="nofollow">https://gist.github.com/juntang-zhuang/0a501dd51c02278d952cf159bc233037</a></li> <li>link to args.yaml: <a href="https://gist.github.com/juntang-zhuang/517ce3c27022b908bb93f78e4f786dc3" rel="nofollow">https://gist.github.com/juntang-zhuang/517ce3c27022b908bb93f78e4f786dc3</a></li>',Jo,J,Fe,Yo,Xt,Wi="Performs a single optimization step.",Tr,L,He,en,Jt,Ui="Implements Adafactor algorithm.",tn,Yt,Qi=`This implementation is based on: <code>Adafactor: Adaptive Learning Rates with Sublinear Memory Cost</code>
(see <a href="https://arxiv.org/abs/1804.04235" rel="nofollow">https://arxiv.org/abs/1804.04235</a>)`,an,ea,ji=`Note that this optimizer internally adjusts the learning rate depending on the
<em>scale_parameter</em>, <em>relative_step</em> and <em>warmup_init</em> options.`,rn,ta,Ki=`To use a manual (external) learning rate schedule you should set <code>scale_parameter=False</code> and
<code>relative_step=False</code>.`,on,Y,Be,nn,aa,Zi="Performs a single optimization step.",zr,R,Re,mn,ra,Xi="PyTorch implementation of BigVision’s Adafactor variant with both single and multi tensor implementations.",sn,oa,Ji='Adapted from <a href="https://github.com/google-research/big_vision" rel="nofollow">https://github.com/google-research/big_vision</a> by Ross Wightman',Dr,T,Ge,ln,na,Yi="Implements the AdaHessian algorithm from “ADAHESSIAN: An Adaptive Second OrderOptimizer for Machine Learning”",pn,ee,Se,dn,ia,em="Gets all parameters in all param_groups with gradients",cn,te,Ve,gn,ma,tm="Computes the Hutchinson approximation of the hessian trace and accumulates it for each trainable parameter.",un,ae,We,fn,sa,am="Performs a single optimization step.",hn,re,Ue,vn,la,rm="Zeros out the accumalated hessian traces.",Mr,Qe,je,Pr,P,Ke,bn,pa,om="Implements AdamW algorithm.",_n,da,nm=`The original Adam algorithm was proposed in <code>Adam: A Method for Stochastic Optimization</code><em>.
The AdamW variant was proposed in <code>Decoupled Weight Decay Regularization</code></em>.`,xn,ca,im=`.. _Adam\\: A Method for Stochastic Optimization:
<a href="https://arxiv.org/abs/1412.6980" rel="nofollow">https://arxiv.org/abs/1412.6980</a>
.. _Decoupled Weight Decay Regularization:
<a href="https://arxiv.org/abs/1711.05101" rel="nofollow">https://arxiv.org/abs/1711.05101</a>
.. _On the Convergence of Adam and Beyond:
<a href="https://openreview.net/forum?id=ryQu7f-RZ" rel="nofollow">https://openreview.net/forum?id=ryQu7f-RZ</a>`,yn,oe,Ze,$n,ga,mm="Performs a single optimization step.",qr,G,Xe,wn,ua,sm=`Implements a pytorch variant of Adan
Adan was proposed in
Adan: Adaptive Nesterov Momentum Algorithm for Faster Optimizing Deep Models[J]. arXiv preprint arXiv:2208.06677, 2022.
<a href="https://arxiv.org/abs/2208.06677" rel="nofollow">https://arxiv.org/abs/2208.06677</a>`,Cn,ne,Je,An,fa,lm="Performs a single optimization step.",kr,S,Ye,Ln,ha,pm='ADOPT: Modified Adam Can Converge with Any β2 with the Optimal Rate: <a href="https://arxiv.org/abs/2411.02853" rel="nofollow">https://arxiv.org/abs/2411.02853</a>',Tn,ie,et,zn,va,dm="Perform a single optimization step.",Er,q,tt,Dn,ba,cm=`Implements a pure pytorch variant of FuseLAMB (NvLamb variant) optimizer from apex.optimizers.FusedLAMB
reference: <a href="https://github.com/NVIDIA/DeepLearningExamples/blob/master/PyTorch/LanguageModeling/Transformer-XL/pytorch/lamb.py" rel="nofollow">https://github.com/NVIDIA/DeepLearningExamples/blob/master/PyTorch/LanguageModeling/Transformer-XL/pytorch/lamb.py</a>`,Mn,_a,gm="LAMB was proposed in <code>Large Batch Optimization for Deep Learning: Training BERT in 76 minutes</code>_.",Pn,xa,um=`.. _Large Batch Optimization for Deep Learning - Training BERT in 76 minutes:
<a href="https://arxiv.org/abs/1904.00962" rel="nofollow">https://arxiv.org/abs/1904.00962</a>
.. _On the Convergence of Adam and Beyond:
<a href="https://openreview.net/forum?id=ryQu7f-RZ" rel="nofollow">https://openreview.net/forum?id=ryQu7f-RZ</a>`,qn,me,at,kn,ya,fm="Performs a single optimization step.",Nr,N,rt,En,$a,hm="LARS for PyTorch",Nn,wa,vm='Paper: <code>Large batch training of Convolutional Networks</code> - <a href="https://arxiv.org/pdf/1708.03888.pdf" rel="nofollow">https://arxiv.org/pdf/1708.03888.pdf</a>',On,se,ot,In,Ca,bm="Performs a single optimization step.",Or,V,nt,Fn,Aa,_m="Implements Lion algorithm.",Hn,le,it,Bn,La,xm="Performs a single optimization step.",Ir,mt,st,Fr,w,lt,Rn,Ta,ym=`MADGRAD_: A Momentumized, Adaptive, Dual Averaged Gradient Method for Stochastic
Optimization.`,Gn,za,$m='.. _MADGRAD: <a href="https://arxiv.org/abs/2101.11075" rel="nofollow">https://arxiv.org/abs/2101.11075</a>',Sn,Da,wm=`MADGRAD is a general purpose optimizer that can be used in place of SGD or
Adam may converge faster and generalize better. Currently GPU-only.
Typically, the same learning rate schedule that is used for SGD or Adam may
be used. The overall learning rate is not comparable to either method and
should be determined by a hyper-parameter sweep.`,Vn,Ma,Cm=`MADGRAD requires less weight decay than other methods, often as little as
zero. Momentum values used for SGD or Adam’s beta1 should work here also.`,Wn,Pa,Am="On sparse problems both weight_decay and momentum should be set to 0.",Un,pe,pt,Qn,qa,Lm="Performs a single optimization step.",Hr,z,dt,jn,ka,Tm="Implements Nadam algorithm (a variant of Adam based on Nesterov momentum).",Kn,Ea,zm="It has been proposed in <code>Incorporating Nesterov Momentum into Adam</code>__.",Zn,Na,Dm='<strong><a href="http://cs229.stanford.edu/proj2015/054_report.pdf" rel="nofollow">http://cs229.stanford.edu/proj2015/054_report.pdf</a></strong> <a href="http://www.cs.toronto.edu/~fritz/absps/momentum.pdf" rel="nofollow">http://www.cs.toronto.edu/~fritz/absps/momentum.pdf</a>',Xn,Oa,Mm=`Originally taken from: <a href="https://github.com/pytorch/pytorch/pull/1408" rel="nofollow">https://github.com/pytorch/pytorch/pull/1408</a>
NOTE: Has potential issues but does work well on some problems.`,Jn,de,ct,Yn,Ia,Pm="Performs a single optimization step.",Br,k,gt,ei,Fa,qm="Implements NAdamW algorithm.",ti,Ha,km=`See Table 1 in <a href="https://arxiv.org/abs/1910.05446" rel="nofollow">https://arxiv.org/abs/1910.05446</a> for the implementation of
the NAdam algorithm (there is also a comment in the code which highlights
the only difference of NAdamW and AdamW).
For further details regarding the algorithm we refer to
<code>Decoupled Weight Decay Regularization</code>_.`,ai,Ba,Em=`.. _Decoupled Weight Decay Regularization:
<a href="https://arxiv.org/abs/1711.05101" rel="nofollow">https://arxiv.org/abs/1711.05101</a>
.. _On the Convergence of Adam and Beyond:
<a href="https://openreview.net/forum?id=ryQu7f-RZ" rel="nofollow">https://openreview.net/forum?id=ryQu7f-RZ</a>`,ri,ce,ut,oi,Ra,Nm="Performs a single optimization step.",Rr,W,ft,ni,Ga,Om="Implements Novograd algorithm.",ii,ge,ht,mi,Sa,Im="Performs a single optimization step.",Gr,vt,bt,Sr,y,_t,si,Va,Fm="Implements RMSprop algorithm (TensorFlow style epsilon)",li,Wa,Hm=`NOTE: This is a direct cut-and-paste of PyTorch RMSprop with eps applied before sqrt
and a few other modifications to closer match Tensorflow for matching hyper-params.`,pi,Ua,Bm="Noteworthy changes include:",di,Qa,Rm="<li>Epsilon applied inside square-root</li> <li>square_avg initialized to ones</li> <li>LR scaling of update accumulated in momentum buffer</li>",ci,ja,Gm=`Proposed by G. Hinton in his
<a href="http://www.cs.toronto.edu/~tijmen/csc321/slides/lecture_slides_lec6.pdf" rel="nofollow">course</a>.`,gi,Ka,Sm=`The centered version first appears in <a href="https://arxiv.org/pdf/1308.0850v5.pdf" rel="nofollow">Generating Sequences
With Recurrent Neural Networks</a>.`,ui,ue,xt,fi,Za,Vm="Performs a single optimization step.",Vr,yt,$t,Wr,X,wt,hi,fe,Ct,vi,Xa,Wm="Performs a single optimization step.",Ur,At,Qr,hr,jr;return ve=new K({props:{title:"Optimization",local:"optimization",headingTag:"h1"}}),_e=new K({props:{title:"Optimizers",local:"optimizers",headingTag:"h2"}}),xe=new K({props:{title:"Factory functions",local:"timm.optim.create_optimizer_v2",headingTag:"h3"}}),ye=new b({props:{name:"timm.optim.create_optimizer_v2",anchor:"timm.optim.create_optimizer_v2",parameters:[{name:"model_or_params",val:": typing.Union[torch.nn.modules.module.Module, typing.Iterator[torch.nn.parameter.Parameter], typing.Iterator[typing.Dict[str, typing.Any]]]"},{name:"opt",val:": str = 'sgd'"},{name:"lr",val:": typing.Optional[float] = None"},{name:"weight_decay",val:": float = 0.0"},{name:"momentum",val:": float = 0.9"},{name:"foreach",val:": typing.Optional[bool] = None"},{name:"filter_bias_and_bn",val:": bool = True"},{name:"layer_decay",val:": typing.Optional[float] = None"},{name:"param_group_fn",val:": typing.Optional[typing.Callable[[torch.nn.modules.module.Module], typing.Union[typing.Iterator[torch.nn.parameter.Parameter], typing.Iterator[typing.Dict[str, typing.Any]]]]] = None"},{name:"**kwargs",val:": typing.Any"}],parametersDescription:[{anchor:"timm.optim.create_optimizer_v2.model_or_params",description:`<strong>model_or_params</strong> &#x2014; A PyTorch model or an iterable of parameters/parameter groups.
If a model is provided, parameters will be automatically extracted and grouped
based on the other arguments.`,name:"model_or_params"},{anchor:"timm.optim.create_optimizer_v2.opt",description:`<strong>opt</strong> &#x2014; Name of the optimizer to create (e.g., &#x2018;adam&#x2019;, &#x2018;adamw&#x2019;, &#x2018;sgd&#x2019;).
Use list_optimizers() to see available options.`,name:"opt"},{anchor:"timm.optim.create_optimizer_v2.lr",description:"<strong>lr</strong> &#x2014; Learning rate. If None, will use the optimizer&#x2019;s default.",name:"lr"},{anchor:"timm.optim.create_optimizer_v2.weight_decay",description:"<strong>weight_decay</strong> &#x2014; Weight decay factor. Will be used to create param groups if model_or_params is a model.",name:"weight_decay"},{anchor:"timm.optim.create_optimizer_v2.momentum",description:`<strong>momentum</strong> &#x2014; Momentum factor for optimizers that support it. Only used if the
chosen optimizer accepts a momentum parameter.`,name:"momentum"},{anchor:"timm.optim.create_optimizer_v2.foreach",description:`<strong>foreach</strong> &#x2014; Enable/disable foreach (multi-tensor) implementation if available.
If None, will use optimizer-specific defaults.`,name:"foreach"},{anchor:"timm.optim.create_optimizer_v2.filter_bias_and_bn",description:`<strong>filter_bias_and_bn</strong> &#x2014; If True, bias, norm layer parameters (all 1d params) will not have
weight decay applied. Only used when model_or_params is a model and
weight_decay &gt; 0.`,name:"filter_bias_and_bn"},{anchor:"timm.optim.create_optimizer_v2.layer_decay",description:`<strong>layer_decay</strong> &#x2014; Optional layer-wise learning rate decay factor. If provided,
learning rates will be scaled by layer_decay^(max_depth - layer_depth).
Only used when model_or_params is a model.`,name:"layer_decay"},{anchor:"timm.optim.create_optimizer_v2.param_group_fn",description:`<strong>param_group_fn</strong> &#x2014; Optional function to create custom parameter groups.
If provided, other parameter grouping options will be ignored.`,name:"param_group_fn"},{anchor:"timm.optim.create_optimizer_v2.*kwargs",description:"*<strong>*kwargs</strong> &#x2014; Additional optimizer-specific arguments (e.g., betas for Adam).",name:"*kwargs"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/_optim_factory.py#L836",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Configured optimizer instance.</p>
`}}),we=new K({props:{title:"Basic usage with a model",local:"basic-usage-with-a-model",headingTag:"h1"}}),Ae=new K({props:{title:"SGD with momentum and weight decay",local:"sgd-with-momentum-and-weight-decay",headingTag:"h1"}}),Te=new K({props:{title:"Adam with layer-wise learning rate decay",local:"adam-with-layer-wise-learning-rate-decay",headingTag:"h1"}}),De=new K({props:{title:"Custom parameter groups",local:"custom-parameter-groups",headingTag:"h1"}}),Me=new b({props:{name:"timm.optim.list_optimizers",anchor:"timm.optim.list_optimizers",parameters:[{name:"filter",val:": typing.Union[str, typing.List[str]] = ''"},{name:"exclude_filters",val:": typing.Optional[typing.List[str]] = None"},{name:"with_description",val:": bool = False"}],parametersDescription:[{anchor:"timm.optim.list_optimizers.filter",description:`<strong>filter</strong> &#x2014; Wildcard style filter string or list of filter strings
(e.g., &#x2018;adam<em>&#x2019; for all Adam variants, or [&#x2018;adam</em>&#x2019;, &#x2018;*8bit&#x2019;] for
Adam variants and 8-bit optimizers). Empty string means no filtering.`,name:"filter"},{anchor:"timm.optim.list_optimizers.exclude_filters",description:`<strong>exclude_filters</strong> &#x2014; Optional list of wildcard patterns to exclude. For example,
[&#x2019;<em>8bit&#x2019;, &#x2018;fused</em>&#x2019;] would exclude 8-bit and fused implementations.`,name:"exclude_filters"},{anchor:"timm.optim.list_optimizers.with_description",description:`<strong>with_description</strong> &#x2014; If True, returns tuples of (name, description) instead of
just names. Descriptions provide brief explanations of optimizer characteristics.`,name:"with_description"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/_optim_factory.py#L739",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>List of optimizer names as strings (e.g., [‘adam’, ‘adamw’, …])
If with_description is True:
List of tuples of (name, description) (e.g., [(‘adam’, ‘Adaptive Moment…’), …])</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If with_description is False</p>
`}}),Pe=new b({props:{name:"timm.optim.get_optimizer_class",anchor:"timm.optim.get_optimizer_class",parameters:[{name:"name",val:": str"},{name:"bind_defaults",val:": bool = True"}],parametersDescription:[{anchor:"timm.optim.get_optimizer_class.name",description:"<strong>name</strong> &#x2014; Name of the optimizer to retrieve (e.g., &#x2018;adam&#x2019;, &#x2018;sgd&#x2019;)",name:"name"},{anchor:"timm.optim.get_optimizer_class.bind_defaults",description:`<strong>bind_defaults</strong> &#x2014; If True, returns a partial function with default arguments from OptimInfo bound.
If False, returns the raw optimizer class.`,name:"bind_defaults"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/_optim_factory.py#L799",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The optimizer class (e.g., torch.optim.Adam)
If bind_defaults is True:
A partial function with default arguments bound</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If bind_defaults is False</p>
`,raiseDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<ul>
<li><code>ValueError</code> — If optimizer name is not found in registry</li>
</ul>
`,raiseType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>ValueError</code></p>
`}}),ke=new K({props:{title:"Get SGD with nesterov momentum default",local:"get-sgd-with-nesterov-momentum-default",headingTag:"h1"}}),Ne=new K({props:{title:"Get raw optimizer class",local:"get-raw-optimizer-class",headingTag:"h1"}}),Oe=new K({props:{title:"Optimizer Classes",local:"timm.optim.AdaBelief",headingTag:"h3"}}),Ie=new b({props:{name:"class timm.optim.AdaBelief",anchor:"timm.optim.AdaBelief",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-16"},{name:"weight_decay",val:" = 0"},{name:"amsgrad",val:" = False"},{name:"decoupled_decay",val:" = True"},{name:"fixed_decay",val:" = False"},{name:"rectify",val:" = True"},{name:"degenerated_to_sgd",val:" = True"}],parametersDescription:[{anchor:"timm.optim.AdaBelief.params",description:`<strong>params</strong> (iterable) &#x2014; iterable of parameters to optimize or dicts defining
parameter groups`,name:"params"},{anchor:"timm.optim.AdaBelief.lr",description:"<strong>lr</strong> (float, optional) &#x2014; learning rate (default: 1e-3)",name:"lr"},{anchor:"timm.optim.AdaBelief.betas",description:`<strong>betas</strong> (Tuple[float, float], optional) &#x2014; coefficients used for computing
running averages of gradient and its square (default: (0.9, 0.999))`,name:"betas"},{anchor:"timm.optim.AdaBelief.eps",description:`<strong>eps</strong> (float, optional) &#x2014; term added to the denominator to improve
numerical stability (default: 1e-16)`,name:"eps"},{anchor:"timm.optim.AdaBelief.weight_decay",description:"<strong>weight_decay</strong> (float, optional) &#x2014; weight decay (L2 penalty) (default: 0)",name:"weight_decay"},{anchor:"timm.optim.AdaBelief.amsgrad",description:`<strong>amsgrad</strong> (boolean, optional) &#x2014; whether to use the AMSGrad variant of this
algorithm from the paper <code>On the Convergence of Adam and Beyond</code>_
(default: False)`,name:"amsgrad"},{anchor:"timm.optim.AdaBelief.decoupled_decay",description:`<strong>decoupled_decay</strong> (boolean, optional) &#x2014; (default: True) If set as True, then
the optimizer uses decoupled weight decay as in AdamW`,name:"decoupled_decay"},{anchor:"timm.optim.AdaBelief.fixed_decay",description:`<strong>fixed_decay</strong> (boolean, optional) &#x2014; (default: False) This is used when weight<em>decouple
is set as True.
When fixed_decay == True, the weight decay is performed as
$W</em>{new} = W<em>{old} - W</em>{old} \\times decay$.
When fixed<em>decay == False, the weight decay is performed as
$W</em>{new} = W<em>{old} - W</em>{old} \\times decay \\times lr$. Note that in this case, the
weight decay ratio decreases with learning rate (lr).`,name:"fixed_decay"},{anchor:"timm.optim.AdaBelief.rectify",description:`<strong>rectify</strong> (boolean, optional) &#x2014; (default: True) If set as True, then perform the rectified
update similar to RAdam`,name:"rectify"},{anchor:"timm.optim.AdaBelief.degenerated_to_sgd",description:`<strong>degenerated_to_sgd</strong> (boolean, optional) (default &#x2014;True) If set as True, then perform SGD update
when variance of gradient is high`,name:"degenerated_to_sgd"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adabelief.py#L6"}}),Fe=new b({props:{name:"step",anchor:"timm.optim.AdaBelief.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.AdaBelief.step.closure",description:`<strong>closure</strong> (callable, optional) &#x2014; A closure that reevaluates the model
and returns the loss.`,name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adabelief.py#L106"}}),He=new b({props:{name:"class timm.optim.Adafactor",anchor:"timm.optim.Adafactor",parameters:[{name:"params",val:""},{name:"lr",val:" = None"},{name:"eps",val:" = 1e-30"},{name:"eps_scale",val:" = 0.001"},{name:"clip_threshold",val:" = 1.0"},{name:"decay_rate",val:" = -0.8"},{name:"betas",val:" = None"},{name:"weight_decay",val:" = 0.0"},{name:"scale_parameter",val:" = True"},{name:"warmup_init",val:" = False"},{name:"min_dim_size_to_factor",val:" = 32"}],parametersDescription:[{anchor:"timm.optim.Adafactor.params",description:"<strong>params</strong> (iterable) &#x2014; iterable of parameters to optimize or dicts defining parameter groups",name:"params"},{anchor:"timm.optim.Adafactor.lr",description:"<strong>lr</strong> (float, optional) &#x2014; external learning rate (default: None)",name:"lr"},{anchor:"timm.optim.Adafactor.eps",description:`<strong>eps</strong> (tuple[float, float]) &#x2014; regularization constants for square gradient
and parameter scale respectively (default: (1e-30, 1e-3))`,name:"eps"},{anchor:"timm.optim.Adafactor.clip_threshold",description:"<strong>clip_threshold</strong> (float) &#x2014; threshold of root mean square of final gradient update (default: 1.0)",name:"clip_threshold"},{anchor:"timm.optim.Adafactor.decay_rate",description:"<strong>decay_rate</strong> (float) &#x2014; coefficient used to compute running averages of square gradient (default: -0.8)",name:"decay_rate"},{anchor:"timm.optim.Adafactor.beta1",description:"<strong>beta1</strong> (float) &#x2014; coefficient used for computing running averages of gradient (default: None)",name:"beta1"},{anchor:"timm.optim.Adafactor.weight_decay",description:"<strong>weight_decay</strong> (float, optional) &#x2014; weight decay (L2 penalty) (default: 0)",name:"weight_decay"},{anchor:"timm.optim.Adafactor.scale_parameter",description:"<strong>scale_parameter</strong> (bool) &#x2014; if True, learning rate is scaled by root mean square of parameter (default: True)",name:"scale_parameter"},{anchor:"timm.optim.Adafactor.warmup_init",description:`<strong>warmup_init</strong> (bool) &#x2014; time-dependent learning rate computation depends on
whether warm-up initialization is being used (default: False)`,name:"warmup_init"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adafactor.py#L17"}}),Be=new b({props:{name:"step",anchor:"timm.optim.Adafactor.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.Adafactor.step.closure",description:"<strong>closure</strong> (callable, optional) &#x2014; A closure that reevaluates the model and returns the loss.",name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adafactor.py#L117"}}),Re=new b({props:{name:"class timm.optim.AdafactorBigVision",anchor:"timm.optim.AdafactorBigVision",parameters:[{name:"params",val:""},{name:"lr",val:": float = 1.0"},{name:"min_dim_size_to_factor",val:": int = 32"},{name:"decay_rate",val:": float = 0.8"},{name:"decay_offset",val:": int = 0"},{name:"beta2_cap",val:": float = 0.999"},{name:"momentum",val:": typing.Optional[float] = 0.9"},{name:"momentum_dtype",val:": typing.Union[str, torch.dtype] = torch.bfloat16"},{name:"eps",val:": typing.Optional[float] = None"},{name:"weight_decay",val:": float = 0.0"},{name:"clipping_threshold",val:": typing.Optional[float] = None"},{name:"unscaled_wd",val:": bool = False"},{name:"foreach",val:": typing.Optional[bool] = False"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adafactor_bv.py#L48"}}),Ge=new b({props:{name:"class timm.optim.Adahessian",anchor:"timm.optim.Adahessian",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.1"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0.0"},{name:"hessian_power",val:" = 1.0"},{name:"update_each",val:" = 1"},{name:"n_samples",val:" = 1"},{name:"avg_conv_kernel",val:" = False"}],parametersDescription:[{anchor:"timm.optim.Adahessian.params",description:"<strong>params</strong> (iterable) &#x2014; iterable of parameters to optimize or dicts defining parameter groups",name:"params"},{anchor:"timm.optim.Adahessian.lr",description:"<strong>lr</strong> (float, optional) &#x2014; learning rate (default: 0.1)",name:"lr"},{anchor:"timm.optim.Adahessian.betas",description:`<strong>betas</strong> ((float, float), optional) &#x2014; coefficients used for computing running averages of gradient and the
squared hessian trace (default: (0.9, 0.999))`,name:"betas"},{anchor:"timm.optim.Adahessian.eps",description:"<strong>eps</strong> (float, optional) &#x2014; term added to the denominator to improve numerical stability (default: 1e-8)",name:"eps"},{anchor:"timm.optim.Adahessian.weight_decay",description:"<strong>weight_decay</strong> (float, optional) &#x2014; weight decay (L2 penalty) (default: 0.0)",name:"weight_decay"},{anchor:"timm.optim.Adahessian.hessian_power",description:"<strong>hessian_power</strong> (float, optional) &#x2014; exponent of the hessian trace (default: 1.0)",name:"hessian_power"},{anchor:"timm.optim.Adahessian.update_each",description:`<strong>update_each</strong> (int, optional) &#x2014; compute the hessian trace approximation only after <em>this</em> number of steps
(to save time) (default: 1)`,name:"update_each"},{anchor:"timm.optim.Adahessian.n_samples",description:"<strong>n_samples</strong> (int, optional) &#x2014; how many times to sample <code>z</code> for the approximation of the hessian trace (default: 1)",name:"n_samples"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adahessian.py#L9"}}),Se=new b({props:{name:"get_params",anchor:"timm.optim.Adahessian.get_params",parameters:[],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adahessian.py#L74"}}),Ve=new b({props:{name:"set_hessian",anchor:"timm.optim.Adahessian.set_hessian",parameters:[],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adahessian.py#L90"}}),We=new b({props:{name:"step",anchor:"timm.optim.Adahessian.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.Adahessian.step.closure",description:"<strong>closure</strong> (callable, optional) &#x2014; a closure that reevaluates the model and returns the loss (default &#x2014; None)",name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adahessian.py#L118"}}),Ue=new b({props:{name:"zero_hessian",anchor:"timm.optim.Adahessian.zero_hessian",parameters:[],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adahessian.py#L81"}}),je=new b({props:{name:"class timm.optim.AdamP",anchor:"timm.optim.AdamP",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"delta",val:" = 0.1"},{name:"wd_ratio",val:" = 0.1"},{name:"nesterov",val:" = False"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adamp.py#L43"}}),Ke=new b({props:{name:"class timm.optim.AdamW",anchor:"timm.optim.AdamW",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0.01"},{name:"amsgrad",val:" = False"}],parametersDescription:[{anchor:"timm.optim.AdamW.params",description:`<strong>params</strong> (iterable) &#x2014; iterable of parameters to optimize or dicts defining
parameter groups`,name:"params"},{anchor:"timm.optim.AdamW.lr",description:"<strong>lr</strong> (float, optional) &#x2014; learning rate (default: 1e-3)",name:"lr"},{anchor:"timm.optim.AdamW.betas",description:`<strong>betas</strong> (Tuple[float, float], optional) &#x2014; coefficients used for computing
running averages of gradient and its square (default: (0.9, 0.999))`,name:"betas"},{anchor:"timm.optim.AdamW.eps",description:`<strong>eps</strong> (float, optional) &#x2014; term added to the denominator to improve
numerical stability (default: 1e-8)`,name:"eps"},{anchor:"timm.optim.AdamW.weight_decay",description:"<strong>weight_decay</strong> (float, optional) &#x2014; weight decay coefficient (default: 1e-2)",name:"weight_decay"},{anchor:"timm.optim.AdamW.amsgrad",description:`<strong>amsgrad</strong> (boolean, optional) &#x2014; whether to use the AMSGrad variant of this
algorithm from the paper <code>On the Convergence of Adam and Beyond</code>_
(default: False)`,name:"amsgrad"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adamw.py#L12"}}),Ze=new b({props:{name:"step",anchor:"timm.optim.AdamW.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.AdamW.step.closure",description:`<strong>closure</strong> (callable, optional) &#x2014; A closure that reevaluates the model
and returns the loss.`,name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adamw.py#L71"}}),Xe=new b({props:{name:"class timm.optim.Adan",anchor:"timm.optim.Adan",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.98, 0.92, 0.99)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0.0"},{name:"no_prox",val:" = False"}],parametersDescription:[{anchor:"timm.optim.Adan.params",description:"<strong>params</strong> (iterable) &#x2014; iterable of parameters to optimize or dicts defining parameter groups.",name:"params"},{anchor:"timm.optim.Adan.lr",description:"<strong>lr</strong> (float, optional) &#x2014; learning rate. (default: 1e-3)",name:"lr"},{anchor:"timm.optim.Adan.betas",description:`<strong>betas</strong> (Tuple[float, float, flot], optional) &#x2014; coefficients used for computing
running averages of gradient and its norm. (default: (0.98, 0.92, 0.99))`,name:"betas"},{anchor:"timm.optim.Adan.eps",description:`<strong>eps</strong> (float, optional) &#x2014; term added to the denominator to improve
numerical stability. (default: 1e-8)`,name:"eps"},{anchor:"timm.optim.Adan.weight_decay",description:"<strong>weight_decay</strong> (float, optional) &#x2014; decoupled weight decay (L2 penalty) (default: 0)",name:"weight_decay"},{anchor:"timm.optim.Adan.no_prox",description:"<strong>no_prox</strong> (bool) &#x2014; how to perform the decoupled weight decay (default: False)",name:"no_prox"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adan.py#L16"}}),Je=new b({props:{name:"step",anchor:"timm.optim.Adan.step",parameters:[{name:"closure",val:" = None"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adan.py#L71"}}),Ye=new b({props:{name:"class timm.optim.Adopt",anchor:"timm.optim.Adopt",parameters:[{name:"params",val:""},{name:"lr",val:": typing.Union[float, torch.Tensor] = 0.001"},{name:"betas",val:": typing.Tuple[float, float] = (0.9, 0.9999)"},{name:"eps",val:": float = 1e-06"},{name:"weight_decay",val:": float = 0.0"},{name:"decoupled",val:": bool = False"},{name:"foreach",val:": typing.Optional[bool] = None"},{name:"maximize",val:": bool = False"},{name:"capturable",val:": bool = False"},{name:"differentiable",val:": bool = False"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adopt.py#L56"}}),et=new b({props:{name:"step",anchor:"timm.optim.Adopt.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.Adopt.step.closure",description:`<strong>closure</strong> (Callable, optional) &#x2014; A closure that reevaluates the model
and returns the loss.`,name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/adopt.py#L191"}}),tt=new b({props:{name:"class timm.optim.Lamb",anchor:"timm.optim.Lamb",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"bias_correction",val:" = True"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-06"},{name:"weight_decay",val:" = 0.01"},{name:"grad_averaging",val:" = True"},{name:"max_grad_norm",val:" = 1.0"},{name:"trust_clip",val:" = False"},{name:"always_adapt",val:" = False"}],parametersDescription:[{anchor:"timm.optim.Lamb.params",description:"<strong>params</strong> (iterable) &#x2014; iterable of parameters to optimize or dicts defining parameter groups.",name:"params"},{anchor:"timm.optim.Lamb.lr",description:"<strong>lr</strong> (float, optional) &#x2014; learning rate. (default: 1e-3)",name:"lr"},{anchor:"timm.optim.Lamb.betas",description:`<strong>betas</strong> (Tuple[float, float], optional) &#x2014; coefficients used for computing
running averages of gradient and its norm. (default: (0.9, 0.999))`,name:"betas"},{anchor:"timm.optim.Lamb.eps",description:`<strong>eps</strong> (float, optional) &#x2014; term added to the denominator to improve
numerical stability. (default: 1e-8)`,name:"eps"},{anchor:"timm.optim.Lamb.weight_decay",description:"<strong>weight_decay</strong> (float, optional) &#x2014; weight decay (L2 penalty) (default: 0)",name:"weight_decay"},{anchor:"timm.optim.Lamb.grad_averaging",description:`<strong>grad_averaging</strong> (bool, optional) &#x2014; whether apply (1-beta2) to grad when
calculating running averages of gradient. (default: True)`,name:"grad_averaging"},{anchor:"timm.optim.Lamb.max_grad_norm",description:"<strong>max_grad_norm</strong> (float, optional) &#x2014; value used to clip global grad norm (default: 1.0)",name:"max_grad_norm"},{anchor:"timm.optim.Lamb.trust_clip",description:"<strong>trust_clip</strong> (bool) &#x2014; enable LAMBC trust ratio clipping (default: False)",name:"trust_clip"},{anchor:"timm.optim.Lamb.always_adapt",description:`<strong>always_adapt</strong> (boolean, optional) &#x2014; Apply adaptive learning rate to 0.0
weight decay parameter (default: False)`,name:"always_adapt"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/lamb.py#L60"}}),at=new b({props:{name:"step",anchor:"timm.optim.Lamb.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.Lamb.step.closure",description:`<strong>closure</strong> (callable, optional) &#x2014; A closure that reevaluates the model
and returns the loss.`,name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/lamb.py#L131"}}),rt=new b({props:{name:"class timm.optim.Lars",anchor:"timm.optim.Lars",parameters:[{name:"params",val:""},{name:"lr",val:" = 1.0"},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"trust_coeff",val:" = 0.001"},{name:"eps",val:" = 1e-08"},{name:"trust_clip",val:" = False"},{name:"always_adapt",val:" = False"}],parametersDescription:[{anchor:"timm.optim.Lars.params",description:"<strong>params</strong> (iterable) &#x2014; iterable of parameters to optimize or dicts defining parameter groups.",name:"params"},{anchor:"timm.optim.Lars.lr",description:"<strong>lr</strong> (float, optional) &#x2014; learning rate (default: 1.0).",name:"lr"},{anchor:"timm.optim.Lars.momentum",description:"<strong>momentum</strong> (float, optional) &#x2014; momentum factor (default: 0)",name:"momentum"},{anchor:"timm.optim.Lars.weight_decay",description:"<strong>weight_decay</strong> (float, optional) &#x2014; weight decay (L2 penalty) (default: 0)",name:"weight_decay"},{anchor:"timm.optim.Lars.dampening",description:"<strong>dampening</strong> (float, optional) &#x2014; dampening for momentum (default: 0)",name:"dampening"},{anchor:"timm.optim.Lars.nesterov",description:"<strong>nesterov</strong> (bool, optional) &#x2014; enables Nesterov momentum (default: False)",name:"nesterov"},{anchor:"timm.optim.Lars.trust_coeff",description:"<strong>trust_coeff</strong> (float) &#x2014; trust coefficient for computing adaptive lr / trust_ratio (default: 0.001)",name:"trust_coeff"},{anchor:"timm.optim.Lars.eps",description:"<strong>eps</strong> (float) &#x2014; eps for division denominator (default: 1e-8)",name:"eps"},{anchor:"timm.optim.Lars.trust_clip",description:"<strong>trust_clip</strong> (bool) &#x2014; enable LARC trust ratio clipping (default: False)",name:"trust_clip"},{anchor:"timm.optim.Lars.always_adapt",description:"<strong>always_adapt</strong> (bool) &#x2014; always apply LARS LR adapt, otherwise only when group weight_decay != 0 (default: False)",name:"always_adapt"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/lars.py#L17"}}),ot=new b({props:{name:"step",anchor:"timm.optim.Lars.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.Lars.step.closure",description:"<strong>closure</strong> (callable, optional) &#x2014; A closure that reevaluates the model and returns the loss.",name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/lars.py#L75"}}),nt=new b({props:{name:"class timm.optim.Lion",anchor:"timm.optim.Lion",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.0001"},{name:"betas",val:" = (0.9, 0.99)"},{name:"weight_decay",val:" = 0.0"},{name:"maximize",val:" = False"},{name:"foreach",val:" = None"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/lion.py#L25"}}),it=new b({props:{name:"step",anchor:"timm.optim.Lion.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.Lion.step.closure",description:`<strong>closure</strong> (callable, optional) &#x2014; A closure that reevaluates the model
and returns the loss.`,name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/lion.py#L69",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>the loss.</p>
`}}),st=new b({props:{name:"class timm.optim.Lookahead",anchor:"timm.optim.Lookahead",parameters:[{name:"base_optimizer",val:""},{name:"alpha",val:" = 0.5"},{name:"k",val:" = 6"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/lookahead.py#L15"}}),lt=new b({props:{name:"class timm.optim.MADGRAD",anchor:"timm.optim.MADGRAD",parameters:[{name:"params",val:": typing.Any"},{name:"lr",val:": float = 0.01"},{name:"momentum",val:": float = 0.9"},{name:"weight_decay",val:": float = 0"},{name:"eps",val:": float = 1e-06"},{name:"decoupled_decay",val:": bool = False"}],parametersDescription:[{anchor:"timm.optim.MADGRAD.params",description:`<strong>params</strong> (iterable) &#x2014;
Iterable of parameters to optimize or dicts defining parameter groups.`,name:"params"},{anchor:"timm.optim.MADGRAD.lr",description:`<strong>lr</strong> (float) &#x2014;
Learning rate (default: 1e-2).`,name:"lr"},{anchor:"timm.optim.MADGRAD.momentum",description:`<strong>momentum</strong> (float) &#x2014;
Momentum value in  the range [0,1) (default: 0.9).`,name:"momentum"},{anchor:"timm.optim.MADGRAD.weight_decay",description:`<strong>weight_decay</strong> (float) &#x2014;
Weight decay, i.e. a L2 penalty (default: 0).`,name:"weight_decay"},{anchor:"timm.optim.MADGRAD.eps",description:`<strong>eps</strong> (float) &#x2014;
Term added to the denominator outside of the root operation to improve numerical stability. (default: 1e-6).`,name:"eps"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/madgrad.py#L24"}}),pt=new b({props:{name:"step",anchor:"timm.optim.MADGRAD.step",parameters:[{name:"closure",val:": typing.Optional[typing.Callable[[], float]] = None"}],parametersDescription:[{anchor:"timm.optim.MADGRAD.step.closure",description:"<strong>closure</strong> (callable, optional) &#x2014; A closure that reevaluates the model and returns the loss.",name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/madgrad.py#L90"}}),dt=new b({props:{name:"class timm.optim.Nadam",anchor:"timm.optim.Nadam",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.002"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"schedule_decay",val:" = 0.004"}],parametersDescription:[{anchor:"timm.optim.Nadam.params",description:`<strong>params</strong> (iterable) &#x2014; iterable of parameters to optimize or dicts defining
parameter groups`,name:"params"},{anchor:"timm.optim.Nadam.lr",description:"<strong>lr</strong> (float, optional) &#x2014; learning rate (default: 2e-3)",name:"lr"},{anchor:"timm.optim.Nadam.betas",description:`<strong>betas</strong> (Tuple[float, float], optional) &#x2014; coefficients used for computing
running averages of gradient and its square`,name:"betas"},{anchor:"timm.optim.Nadam.eps",description:`<strong>eps</strong> (float, optional) &#x2014; term added to the denominator to improve
numerical stability (default: 1e-8)`,name:"eps"},{anchor:"timm.optim.Nadam.weight_decay",description:"<strong>weight_decay</strong> (float, optional) &#x2014; weight decay (L2 penalty) (default: 0)",name:"weight_decay"},{anchor:"timm.optim.Nadam.schedule_decay",description:"<strong>schedule_decay</strong> (float, optional) &#x2014; momentum schedule decay (default: 4e-3)",name:"schedule_decay"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/nadam.py#L7"}}),ct=new b({props:{name:"step",anchor:"timm.optim.Nadam.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.Nadam.step.closure",description:`<strong>closure</strong> (callable, optional) &#x2014; A closure that reevaluates the model
and returns the loss.`,name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/nadam.py#L50"}}),gt=new b({props:{name:"class timm.optim.NAdamW",anchor:"timm.optim.NAdamW",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0.01"},{name:"maximize",val:": bool = False"},{name:"foreach",val:": typing.Optional[bool] = None"},{name:"capturable",val:": bool = False"}],parametersDescription:[{anchor:"timm.optim.NAdamW.params",description:`<strong>params</strong> (iterable) &#x2014; iterable of parameters to optimize or dicts defining
parameter groups`,name:"params"},{anchor:"timm.optim.NAdamW.lr",description:"<strong>lr</strong> (float, optional) &#x2014; learning rate (default: 1e-3)",name:"lr"},{anchor:"timm.optim.NAdamW.betas",description:`<strong>betas</strong> (Tuple[float, float], optional) &#x2014; coefficients used for computing
running averages of gradient and its square (default: (0.9, 0.999))`,name:"betas"},{anchor:"timm.optim.NAdamW.eps",description:`<strong>eps</strong> (float, optional) &#x2014; term added to the denominator to improve
numerical stability (default: 1e-8)`,name:"eps"},{anchor:"timm.optim.NAdamW.weight_decay",description:"<strong>weight_decay</strong> (float, optional) &#x2014; weight decay coefficient (default: 1e-2)",name:"weight_decay"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/nadamw.py#L15"}}),ut=new b({props:{name:"step",anchor:"timm.optim.NAdamW.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.NAdamW.step.closure",description:`<strong>closure</strong> (callable, optional) &#x2014; A closure that reevaluates the model
and returns the loss.`,name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/nadamw.py#L80"}}),ft=new b({props:{name:"class timm.optim.NvNovoGrad",anchor:"timm.optim.NvNovoGrad",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.95, 0.98)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"},{name:"grad_averaging",val:" = False"},{name:"amsgrad",val:" = False"}],parametersDescription:[{anchor:"timm.optim.NvNovoGrad.params",description:`<strong>params</strong> (iterable) &#x2014; iterable of parameters to optimize or dicts defining
parameter groups`,name:"params"},{anchor:"timm.optim.NvNovoGrad.lr",description:"<strong>lr</strong> (float, optional) &#x2014; learning rate (default: 1e-3)",name:"lr"},{anchor:"timm.optim.NvNovoGrad.betas",description:`<strong>betas</strong> (Tuple[float, float], optional) &#x2014; coefficients used for computing
running averages of gradient and its square (default: (0.95, 0.98))`,name:"betas"},{anchor:"timm.optim.NvNovoGrad.eps",description:`<strong>eps</strong> (float, optional) &#x2014; term added to the denominator to improve
numerical stability (default: 1e-8)`,name:"eps"},{anchor:"timm.optim.NvNovoGrad.weight_decay",description:"<strong>weight_decay</strong> (float, optional) &#x2014; weight decay (L2 penalty) (default: 0)",name:"weight_decay"},{anchor:"timm.optim.NvNovoGrad.grad_averaging",description:"<strong>grad_averaging</strong> &#x2014; gradient averaging",name:"grad_averaging"},{anchor:"timm.optim.NvNovoGrad.amsgrad",description:`<strong>amsgrad</strong> (boolean, optional) &#x2014; whether to use the AMSGrad variant of this
algorithm from the paper <code>On the Convergence of Adam and Beyond</code>_
(default: False)`,name:"amsgrad"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/nvnovograd.py#L13"}}),ht=new b({props:{name:"step",anchor:"timm.optim.NvNovoGrad.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.NvNovoGrad.step.closure",description:"<strong>closure</strong> (callable, optional) &#x2014; A closure that reevaluates the model",name:"closure"},{anchor:"timm.optim.NvNovoGrad.step.and",description:"<strong>and</strong> returns the loss. &#x2014;",name:"and"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/nvnovograd.py#L66"}}),bt=new b({props:{name:"class timm.optim.RAdam",anchor:"timm.optim.RAdam",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"betas",val:" = (0.9, 0.999)"},{name:"eps",val:" = 1e-08"},{name:"weight_decay",val:" = 0"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/radam.py#L10"}}),_t=new b({props:{name:"class timm.optim.RMSpropTF",anchor:"timm.optim.RMSpropTF",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.01"},{name:"alpha",val:" = 0.9"},{name:"eps",val:" = 1e-10"},{name:"weight_decay",val:" = 0"},{name:"momentum",val:" = 0.0"},{name:"centered",val:" = False"},{name:"decoupled_decay",val:" = False"},{name:"lr_in_momentum",val:" = True"}],parametersDescription:[{anchor:"timm.optim.RMSpropTF.params",description:`<strong>params</strong> (iterable) &#x2014; iterable of parameters to optimize or dicts defining
parameter groups`,name:"params"},{anchor:"timm.optim.RMSpropTF.lr",description:"<strong>lr</strong> (float, optional) &#x2014; learning rate (default: 1e-2)",name:"lr"},{anchor:"timm.optim.RMSpropTF.momentum",description:"<strong>momentum</strong> (float, optional) &#x2014; momentum factor (default: 0)",name:"momentum"},{anchor:"timm.optim.RMSpropTF.alpha",description:"<strong>alpha</strong> (float, optional) &#x2014; smoothing (decay) constant (default: 0.9)",name:"alpha"},{anchor:"timm.optim.RMSpropTF.eps",description:`<strong>eps</strong> (float, optional) &#x2014; term added to the denominator to improve
numerical stability (default: 1e-10)`,name:"eps"},{anchor:"timm.optim.RMSpropTF.centered",description:`<strong>centered</strong> (bool, optional)  &#x2014; if <code>True</code>, compute the centered RMSProp,
the gradient is normalized by an estimation of its variance`,name:"centered"},{anchor:"timm.optim.RMSpropTF.weight_decay",description:"<strong>weight_decay</strong> (float, optional) &#x2014; weight decay (L2 penalty) (default: 0)",name:"weight_decay"},{anchor:"timm.optim.RMSpropTF.decoupled_decay",description:'<strong>decoupled_decay</strong> (bool, optional) &#x2014; decoupled weight decay as per <a href="https://arxiv.org/abs/1711.05101" rel="nofollow">https://arxiv.org/abs/1711.05101</a>',name:"decoupled_decay"},{anchor:"timm.optim.RMSpropTF.lr_in_momentum",description:`<strong>lr_in_momentum</strong> (bool, optional) &#x2014; learning rate scaling is included in the momentum buffer
update as per defaults in Tensorflow`,name:"lr_in_momentum"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/rmsprop_tf.py#L14"}}),xt=new b({props:{name:"step",anchor:"timm.optim.RMSpropTF.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.RMSpropTF.step.closure",description:`<strong>closure</strong> (callable, optional) &#x2014; A closure that reevaluates the model
and returns the loss.`,name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/rmsprop_tf.py#L89"}}),$t=new b({props:{name:"class timm.optim.SGDP",anchor:"timm.optim.SGDP",parameters:[{name:"params",val:""},{name:"lr",val:" = <required parameter>"},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"eps",val:" = 1e-08"},{name:"delta",val:" = 0.1"},{name:"wd_ratio",val:" = 0.1"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/sgdp.py#L19"}}),wt=new b({props:{name:"class timm.optim.SGDW",anchor:"timm.optim.SGDW",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"maximize",val:": bool = False"},{name:"foreach",val:": typing.Optional[bool] = None"},{name:"differentiable",val:": bool = False"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/sgdw.py#L16"}}),Ct=new b({props:{name:"step",anchor:"timm.optim.SGDW.step",parameters:[{name:"closure",val:" = None"}],parametersDescription:[{anchor:"timm.optim.SGDW.step.closure",description:`<strong>closure</strong> (Callable, optional) &#x2014; A closure that reevaluates the model
and returns the loss.`,name:"closure"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/optim/sgdw.py#L79"}}),At=new us({props:{source:"https://github.com/huggingface/pytorch-image-models/blob/main/hfdocs/source/reference/optimizers.mdx"}}),{c(){Z=a("meta"),vr=o(),rr=a("p"),br=o(),d(ve.$$.fragment),_r=o(),be=a("p"),be.innerHTML=_i,xr=o(),d(_e.$$.fragment),yr=o(),d(xe.$$.fragment),$r=o(),_=a("div"),d(ye.$$.fragment),yo=o(),Lt=a("p"),Lt.textContent=xi,$o=o(),Tt=a("p"),Tt.textContent=yi,wo=o(),zt=a("p"),zt.textContent=$i,Co=o(),or=a("blockquote"),nr=a("blockquote"),$e=a("blockquote"),d(we.$$.fragment),Ao=o(),Dt=a("p"),Dt.textContent=wi,Lo=o(),ir=a("blockquote"),mr=a("blockquote"),Ce=a("blockquote"),d(Ae.$$.fragment),To=o(),Mt=a("p"),Mt.textContent=Ci,zo=o(),sr=a("blockquote"),lr=a("blockquote"),Le=a("blockquote"),d(Te.$$.fragment),Do=o(),Pt=a("p"),Pt.textContent=Ai,Mo=o(),pr=a("blockquote"),dr=a("blockquote"),ze=a("blockquote"),d(De.$$.fragment),Po=o(),qt=a("p"),qt.textContent=Li,qo=o(),kt=a("p"),kt.textContent=Ti,ko=o(),Et=a("ol"),Et.innerHTML=zi,wr=o(),x=a("div"),d(Me.$$.fragment),Eo=o(),Nt=a("p"),Nt.textContent=Di,No=o(),Ot=a("p"),Ot.textContent=Mi,Oo=o(),It=a("p"),It.textContent=Pi,Io=o(),Ft=a("blockquote"),Ft.innerHTML=qi,Fo=o(),Ht=a("blockquote"),Ht.innerHTML=ki,Ho=o(),Bt=a("blockquote"),Bt.innerHTML=Ei,Bo=o(),Rt=a("blockquote"),Rt.innerHTML=Ni,Cr=o(),C=a("div"),d(Pe.$$.fragment),Ro=o(),Gt=a("p"),Gt.textContent=Oi,Go=o(),St=a("p"),St.textContent=Ii,So=o(),Vt=a("p"),Vt.textContent=Fi,Vo=o(),cr=a("blockquote"),gr=a("blockquote"),qe=a("blockquote"),d(ke.$$.fragment),Wo=o(),Wt=a("p"),Wt.textContent=Hi,Uo=o(),ur=a("blockquote"),fr=a("blockquote"),Ee=a("blockquote"),d(Ne.$$.fragment),Qo=o(),Ut=a("p"),Ut.textContent=Bi,Ar=o(),d(Oe.$$.fragment),Lr=o(),A=a("div"),d(Ie.$$.fragment),jo=o(),Qt=a("p"),Qt.textContent=Ri,Ko=o(),jt=a("p"),jt.textContent=Gi,Zo=o(),Kt=a("p"),Kt.innerHTML=Si,Xo=o(),Zt=a("ul"),Zt.innerHTML=Vi,Jo=o(),J=a("div"),d(Fe.$$.fragment),Yo=o(),Xt=a("p"),Xt.textContent=Wi,Tr=o(),L=a("div"),d(He.$$.fragment),en=o(),Jt=a("p"),Jt.textContent=Ui,tn=o(),Yt=a("p"),Yt.innerHTML=Qi,an=o(),ea=a("p"),ea.innerHTML=ji,rn=o(),ta=a("p"),ta.innerHTML=Ki,on=o(),Y=a("div"),d(Be.$$.fragment),nn=o(),aa=a("p"),aa.textContent=Zi,zr=o(),R=a("div"),d(Re.$$.fragment),mn=o(),ra=a("p"),ra.textContent=Xi,sn=o(),oa=a("p"),oa.innerHTML=Ji,Dr=o(),T=a("div"),d(Ge.$$.fragment),ln=o(),na=a("p"),na.textContent=Yi,pn=o(),ee=a("div"),d(Se.$$.fragment),dn=o(),ia=a("p"),ia.textContent=em,cn=o(),te=a("div"),d(Ve.$$.fragment),gn=o(),ma=a("p"),ma.textContent=tm,un=o(),ae=a("div"),d(We.$$.fragment),fn=o(),sa=a("p"),sa.textContent=am,hn=o(),re=a("div"),d(Ue.$$.fragment),vn=o(),la=a("p"),la.textContent=rm,Mr=o(),Qe=a("div"),d(je.$$.fragment),Pr=o(),P=a("div"),d(Ke.$$.fragment),bn=o(),pa=a("p"),pa.textContent=om,_n=o(),da=a("p"),da.innerHTML=nm,xn=o(),ca=a("p"),ca.innerHTML=im,yn=o(),oe=a("div"),d(Ze.$$.fragment),$n=o(),ga=a("p"),ga.textContent=mm,qr=o(),G=a("div"),d(Xe.$$.fragment),wn=o(),ua=a("p"),ua.innerHTML=sm,Cn=o(),ne=a("div"),d(Je.$$.fragment),An=o(),fa=a("p"),fa.textContent=lm,kr=o(),S=a("div"),d(Ye.$$.fragment),Ln=o(),ha=a("p"),ha.innerHTML=pm,Tn=o(),ie=a("div"),d(et.$$.fragment),zn=o(),va=a("p"),va.textContent=dm,Er=o(),q=a("div"),d(tt.$$.fragment),Dn=o(),ba=a("p"),ba.innerHTML=cm,Mn=o(),_a=a("p"),_a.innerHTML=gm,Pn=o(),xa=a("p"),xa.innerHTML=um,qn=o(),me=a("div"),d(at.$$.fragment),kn=o(),ya=a("p"),ya.textContent=fm,Nr=o(),N=a("div"),d(rt.$$.fragment),En=o(),$a=a("p"),$a.textContent=hm,Nn=o(),wa=a("p"),wa.innerHTML=vm,On=o(),se=a("div"),d(ot.$$.fragment),In=o(),Ca=a("p"),Ca.textContent=bm,Or=o(),V=a("div"),d(nt.$$.fragment),Fn=o(),Aa=a("p"),Aa.textContent=_m,Hn=o(),le=a("div"),d(it.$$.fragment),Bn=o(),La=a("p"),La.textContent=xm,Ir=o(),mt=a("div"),d(st.$$.fragment),Fr=o(),w=a("div"),d(lt.$$.fragment),Rn=o(),Ta=a("p"),Ta.textContent=ym,Gn=o(),za=a("p"),za.innerHTML=$m,Sn=o(),Da=a("p"),Da.textContent=wm,Vn=o(),Ma=a("p"),Ma.textContent=Cm,Wn=o(),Pa=a("p"),Pa.textContent=Am,Un=o(),pe=a("div"),d(pt.$$.fragment),Qn=o(),qa=a("p"),qa.textContent=Lm,Hr=o(),z=a("div"),d(dt.$$.fragment),jn=o(),ka=a("p"),ka.textContent=Tm,Kn=o(),Ea=a("p"),Ea.innerHTML=zm,Zn=o(),Na=a("p"),Na.innerHTML=Dm,Xn=o(),Oa=a("p"),Oa.innerHTML=Mm,Jn=o(),de=a("div"),d(ct.$$.fragment),Yn=o(),Ia=a("p"),Ia.textContent=Pm,Br=o(),k=a("div"),d(gt.$$.fragment),ei=o(),Fa=a("p"),Fa.textContent=qm,ti=o(),Ha=a("p"),Ha.innerHTML=km,ai=o(),Ba=a("p"),Ba.innerHTML=Em,ri=o(),ce=a("div"),d(ut.$$.fragment),oi=o(),Ra=a("p"),Ra.textContent=Nm,Rr=o(),W=a("div"),d(ft.$$.fragment),ni=o(),Ga=a("p"),Ga.textContent=Om,ii=o(),ge=a("div"),d(ht.$$.fragment),mi=o(),Sa=a("p"),Sa.textContent=Im,Gr=o(),vt=a("div"),d(bt.$$.fragment),Sr=o(),y=a("div"),d(_t.$$.fragment),si=o(),Va=a("p"),Va.textContent=Fm,li=o(),Wa=a("p"),Wa.textContent=Hm,pi=o(),Ua=a("p"),Ua.textContent=Bm,di=o(),Qa=a("ol"),Qa.innerHTML=Rm,ci=o(),ja=a("p"),ja.innerHTML=Gm,gi=o(),Ka=a("p"),Ka.innerHTML=Sm,ui=o(),ue=a("div"),d(xt.$$.fragment),fi=o(),Za=a("p"),Za.textContent=Vm,Vr=o(),yt=a("div"),d($t.$$.fragment),Wr=o(),X=a("div"),d(wt.$$.fragment),hi=o(),fe=a("div"),d(Ct.$$.fragment),vi=o(),Xa=a("p"),Xa.textContent=Wm,Ur=o(),d(At.$$.fragment),Qr=o(),hr=a("p"),this.h()},l(e){const s=gs("svelte-u9bgzb",document.head);Z=r(s,"META",{name:!0,content:!0}),s.forEach(i),vr=n(e),rr=r(e,"P",{}),l(rr).forEach(i),br=n(e),c(ve.$$.fragment,e),_r=n(e),be=r(e,"P",{"data-svelte-h":!0}),m(be)!=="svelte-1c6qm22"&&(be.innerHTML=_i),xr=n(e),c(_e.$$.fragment,e),yr=n(e),c(xe.$$.fragment,e),$r=n(e),_=r(e,"DIV",{class:!0});var $=l(_);c(ye.$$.fragment,$),yo=n($),Lt=r($,"P",{"data-svelte-h":!0}),m(Lt)!=="svelte-1330e7"&&(Lt.textContent=xi),$o=n($),Tt=r($,"P",{"data-svelte-h":!0}),m(Tt)!=="svelte-9cjiwr"&&(Tt.textContent=yi),wo=n($),zt=r($,"P",{"data-svelte-h":!0}),m(zt)!=="svelte-kvfsh7"&&(zt.textContent=$i),Co=n($),or=r($,"BLOCKQUOTE",{});var Um=l(or);nr=r(Um,"BLOCKQUOTE",{});var Qm=l(nr);$e=r(Qm,"BLOCKQUOTE",{});var Kr=l($e);c(we.$$.fragment,Kr),Ao=n(Kr),Dt=r(Kr,"P",{"data-svelte-h":!0}),m(Dt)!=="svelte-180ncmf"&&(Dt.textContent=wi),Kr.forEach(i),Qm.forEach(i),Um.forEach(i),Lo=n($),ir=r($,"BLOCKQUOTE",{});var jm=l(ir);mr=r(jm,"BLOCKQUOTE",{});var Km=l(mr);Ce=r(Km,"BLOCKQUOTE",{});var Zr=l(Ce);c(Ae.$$.fragment,Zr),To=n(Zr),Mt=r(Zr,"P",{"data-svelte-h":!0}),m(Mt)!=="svelte-6yrpk7"&&(Mt.textContent=Ci),Zr.forEach(i),Km.forEach(i),jm.forEach(i),zo=n($),sr=r($,"BLOCKQUOTE",{});var Zm=l(sr);lr=r(Zm,"BLOCKQUOTE",{});var Xm=l(lr);Le=r(Xm,"BLOCKQUOTE",{});var Xr=l(Le);c(Te.$$.fragment,Xr),Do=n(Xr),Pt=r(Xr,"P",{"data-svelte-h":!0}),m(Pt)!=="svelte-1vmtu70"&&(Pt.textContent=Ai),Xr.forEach(i),Xm.forEach(i),Zm.forEach(i),Mo=n($),pr=r($,"BLOCKQUOTE",{});var Jm=l(pr);dr=r(Jm,"BLOCKQUOTE",{});var Ym=l(dr);ze=r(Ym,"BLOCKQUOTE",{});var Jr=l(ze);c(De.$$.fragment,Jr),Po=n(Jr),qt=r(Jr,"P",{"data-svelte-h":!0}),m(qt)!=="svelte-15ovmpe"&&(qt.textContent=Li),Jr.forEach(i),Ym.forEach(i),Jm.forEach(i),qo=n($),kt=r($,"P",{"data-svelte-h":!0}),m(kt)!=="svelte-sgpn75"&&(kt.textContent=Ti),ko=n($),Et=r($,"OL",{"data-svelte-h":!0}),m(Et)!=="svelte-psaz57"&&(Et.innerHTML=zi),$.forEach(i),wr=n(e),x=r(e,"DIV",{class:!0});var D=l(x);c(Me.$$.fragment,D),Eo=n(D),Nt=r(D,"P",{"data-svelte-h":!0}),m(Nt)!=="svelte-1h2sspw"&&(Nt.textContent=Di),No=n(D),Ot=r(D,"P",{"data-svelte-h":!0}),m(Ot)!=="svelte-1tapwxe"&&(Ot.textContent=Mi),Oo=n(D),It=r(D,"P",{"data-svelte-h":!0}),m(It)!=="svelte-kvfsh7"&&(It.textContent=Pi),Io=n(D),Ft=r(D,"BLOCKQUOTE",{"data-svelte-h":!0}),m(Ft)!=="svelte-m875zf"&&(Ft.innerHTML=qi),Fo=n(D),Ht=r(D,"BLOCKQUOTE",{"data-svelte-h":!0}),m(Ht)!=="svelte-1mioyvo"&&(Ht.innerHTML=ki),Ho=n(D),Bt=r(D,"BLOCKQUOTE",{"data-svelte-h":!0}),m(Bt)!=="svelte-ji9gfr"&&(Bt.innerHTML=Ei),Bo=n(D),Rt=r(D,"BLOCKQUOTE",{"data-svelte-h":!0}),m(Rt)!=="svelte-tvmm3x"&&(Rt.innerHTML=Ni),D.forEach(i),Cr=n(e),C=r(e,"DIV",{class:!0});var O=l(C);c(Pe.$$.fragment,O),Ro=n(O),Gt=r(O,"P",{"data-svelte-h":!0}),m(Gt)!=="svelte-1rcjgrx"&&(Gt.textContent=Oi),Go=n(O),St=r(O,"P",{"data-svelte-h":!0}),m(St)!=="svelte-13jhmtj"&&(St.textContent=Ii),So=n(O),Vt=r(O,"P",{"data-svelte-h":!0}),m(Vt)!=="svelte-kvfsh7"&&(Vt.textContent=Fi),Vo=n(O),cr=r(O,"BLOCKQUOTE",{});var es=l(cr);gr=r(es,"BLOCKQUOTE",{});var ts=l(gr);qe=r(ts,"BLOCKQUOTE",{});var Yr=l(qe);c(ke.$$.fragment,Yr),Wo=n(Yr),Wt=r(Yr,"P",{"data-svelte-h":!0}),m(Wt)!=="svelte-1en25gb"&&(Wt.textContent=Hi),Yr.forEach(i),ts.forEach(i),es.forEach(i),Uo=n(O),ur=r(O,"BLOCKQUOTE",{});var as=l(ur);fr=r(as,"BLOCKQUOTE",{});var rs=l(fr);Ee=r(rs,"BLOCKQUOTE",{});var eo=l(Ee);c(Ne.$$.fragment,eo),Qo=n(eo),Ut=r(eo,"P",{"data-svelte-h":!0}),m(Ut)!=="svelte-gfx8y2"&&(Ut.textContent=Bi),eo.forEach(i),rs.forEach(i),as.forEach(i),O.forEach(i),Ar=n(e),c(Oe.$$.fragment,e),Lr=n(e),A=r(e,"DIV",{class:!0});var I=l(A);c(Ie.$$.fragment,I),jo=n(I),Qt=r(I,"P",{"data-svelte-h":!0}),m(Qt)!=="svelte-1hnunr4"&&(Qt.textContent=Ri),Ko=n(I),jt=r(I,"P",{"data-svelte-h":!0}),m(jt)!=="svelte-1cjb7xo"&&(jt.textContent=Gi),Zo=n(I),Kt=r(I,"P",{"data-svelte-h":!0}),m(Kt)!=="svelte-1347q2l"&&(Kt.innerHTML=Si),Xo=n(I),Zt=r(I,"UL",{"data-svelte-h":!0}),m(Zt)!=="svelte-12x3l9q"&&(Zt.innerHTML=Vi),Jo=n(I),J=r(I,"DIV",{class:!0});var to=l(J);c(Fe.$$.fragment,to),Yo=n(to),Xt=r(to,"P",{"data-svelte-h":!0}),m(Xt)!=="svelte-1gr03w4"&&(Xt.textContent=Wi),to.forEach(i),I.forEach(i),Tr=n(e),L=r(e,"DIV",{class:!0});var F=l(L);c(He.$$.fragment,F),en=n(F),Jt=r(F,"P",{"data-svelte-h":!0}),m(Jt)!=="svelte-1j9mkxe"&&(Jt.textContent=Ui),tn=n(F),Yt=r(F,"P",{"data-svelte-h":!0}),m(Yt)!=="svelte-1xvyiun"&&(Yt.innerHTML=Qi),an=n(F),ea=r(F,"P",{"data-svelte-h":!0}),m(ea)!=="svelte-1i7ubkr"&&(ea.innerHTML=ji),rn=n(F),ta=r(F,"P",{"data-svelte-h":!0}),m(ta)!=="svelte-96f97i"&&(ta.innerHTML=Ki),on=n(F),Y=r(F,"DIV",{class:!0});var ao=l(Y);c(Be.$$.fragment,ao),nn=n(ao),aa=r(ao,"P",{"data-svelte-h":!0}),m(aa)!=="svelte-1gr03w4"&&(aa.textContent=Zi),ao.forEach(i),F.forEach(i),zr=n(e),R=r(e,"DIV",{class:!0});var Ja=l(R);c(Re.$$.fragment,Ja),mn=n(Ja),ra=r(Ja,"P",{"data-svelte-h":!0}),m(ra)!=="svelte-19t8yzj"&&(ra.textContent=Xi),sn=n(Ja),oa=r(Ja,"P",{"data-svelte-h":!0}),m(oa)!=="svelte-aajaln"&&(oa.innerHTML=Ji),Ja.forEach(i),Dr=n(e),T=r(e,"DIV",{class:!0});var H=l(T);c(Ge.$$.fragment,H),ln=n(H),na=r(H,"P",{"data-svelte-h":!0}),m(na)!=="svelte-1cuo0rh"&&(na.textContent=Yi),pn=n(H),ee=r(H,"DIV",{class:!0});var ro=l(ee);c(Se.$$.fragment,ro),dn=n(ro),ia=r(ro,"P",{"data-svelte-h":!0}),m(ia)!=="svelte-1jz1hl7"&&(ia.textContent=em),ro.forEach(i),cn=n(H),te=r(H,"DIV",{class:!0});var oo=l(te);c(Ve.$$.fragment,oo),gn=n(oo),ma=r(oo,"P",{"data-svelte-h":!0}),m(ma)!=="svelte-1y1oyzd"&&(ma.textContent=tm),oo.forEach(i),un=n(H),ae=r(H,"DIV",{class:!0});var no=l(ae);c(We.$$.fragment,no),fn=n(no),sa=r(no,"P",{"data-svelte-h":!0}),m(sa)!=="svelte-1gr03w4"&&(sa.textContent=am),no.forEach(i),hn=n(H),re=r(H,"DIV",{class:!0});var io=l(re);c(Ue.$$.fragment,io),vn=n(io),la=r(io,"P",{"data-svelte-h":!0}),m(la)!=="svelte-4lvf5h"&&(la.textContent=rm),io.forEach(i),H.forEach(i),Mr=n(e),Qe=r(e,"DIV",{class:!0});var os=l(Qe);c(je.$$.fragment,os),os.forEach(i),Pr=n(e),P=r(e,"DIV",{class:!0});var U=l(P);c(Ke.$$.fragment,U),bn=n(U),pa=r(U,"P",{"data-svelte-h":!0}),m(pa)!=="svelte-c51pd7"&&(pa.textContent=om),_n=n(U),da=r(U,"P",{"data-svelte-h":!0}),m(da)!=="svelte-1cgyzi6"&&(da.innerHTML=nm),xn=n(U),ca=r(U,"P",{"data-svelte-h":!0}),m(ca)!=="svelte-1pe3ewc"&&(ca.innerHTML=im),yn=n(U),oe=r(U,"DIV",{class:!0});var mo=l(oe);c(Ze.$$.fragment,mo),$n=n(mo),ga=r(mo,"P",{"data-svelte-h":!0}),m(ga)!=="svelte-1gr03w4"&&(ga.textContent=mm),mo.forEach(i),U.forEach(i),qr=n(e),G=r(e,"DIV",{class:!0});var Ya=l(G);c(Xe.$$.fragment,Ya),wn=n(Ya),ua=r(Ya,"P",{"data-svelte-h":!0}),m(ua)!=="svelte-acz7r2"&&(ua.innerHTML=sm),Cn=n(Ya),ne=r(Ya,"DIV",{class:!0});var so=l(ne);c(Je.$$.fragment,so),An=n(so),fa=r(so,"P",{"data-svelte-h":!0}),m(fa)!=="svelte-1gr03w4"&&(fa.textContent=lm),so.forEach(i),Ya.forEach(i),kr=n(e),S=r(e,"DIV",{class:!0});var er=l(S);c(Ye.$$.fragment,er),Ln=n(er),ha=r(er,"P",{"data-svelte-h":!0}),m(ha)!=="svelte-bxurot"&&(ha.innerHTML=pm),Tn=n(er),ie=r(er,"DIV",{class:!0});var lo=l(ie);c(et.$$.fragment,lo),zn=n(lo),va=r(lo,"P",{"data-svelte-h":!0}),m(va)!=="svelte-1siu6mf"&&(va.textContent=dm),lo.forEach(i),er.forEach(i),Er=n(e),q=r(e,"DIV",{class:!0});var Q=l(q);c(tt.$$.fragment,Q),Dn=n(Q),ba=r(Q,"P",{"data-svelte-h":!0}),m(ba)!=="svelte-d5zqgn"&&(ba.innerHTML=cm),Mn=n(Q),_a=r(Q,"P",{"data-svelte-h":!0}),m(_a)!=="svelte-1wamkfv"&&(_a.innerHTML=gm),Pn=n(Q),xa=r(Q,"P",{"data-svelte-h":!0}),m(xa)!=="svelte-dty621"&&(xa.innerHTML=um),qn=n(Q),me=r(Q,"DIV",{class:!0});var po=l(me);c(at.$$.fragment,po),kn=n(po),ya=r(po,"P",{"data-svelte-h":!0}),m(ya)!=="svelte-1gr03w4"&&(ya.textContent=fm),po.forEach(i),Q.forEach(i),Nr=n(e),N=r(e,"DIV",{class:!0});var he=l(N);c(rt.$$.fragment,he),En=n(he),$a=r(he,"P",{"data-svelte-h":!0}),m($a)!=="svelte-vzcsb8"&&($a.textContent=hm),Nn=n(he),wa=r(he,"P",{"data-svelte-h":!0}),m(wa)!=="svelte-euart9"&&(wa.innerHTML=vm),On=n(he),se=r(he,"DIV",{class:!0});var co=l(se);c(ot.$$.fragment,co),In=n(co),Ca=r(co,"P",{"data-svelte-h":!0}),m(Ca)!=="svelte-1gr03w4"&&(Ca.textContent=bm),co.forEach(i),he.forEach(i),Or=n(e),V=r(e,"DIV",{class:!0});var tr=l(V);c(nt.$$.fragment,tr),Fn=n(tr),Aa=r(tr,"P",{"data-svelte-h":!0}),m(Aa)!=="svelte-pwyp7b"&&(Aa.textContent=_m),Hn=n(tr),le=r(tr,"DIV",{class:!0});var go=l(le);c(it.$$.fragment,go),Bn=n(go),La=r(go,"P",{"data-svelte-h":!0}),m(La)!=="svelte-1gr03w4"&&(La.textContent=xm),go.forEach(i),tr.forEach(i),Ir=n(e),mt=r(e,"DIV",{class:!0});var ns=l(mt);c(st.$$.fragment,ns),ns.forEach(i),Fr=n(e),w=r(e,"DIV",{class:!0});var E=l(w);c(lt.$$.fragment,E),Rn=n(E),Ta=r(E,"P",{"data-svelte-h":!0}),m(Ta)!=="svelte-wmmdpx"&&(Ta.textContent=ym),Gn=n(E),za=r(E,"P",{"data-svelte-h":!0}),m(za)!=="svelte-12dyngi"&&(za.innerHTML=$m),Sn=n(E),Da=r(E,"P",{"data-svelte-h":!0}),m(Da)!=="svelte-qjjdis"&&(Da.textContent=wm),Vn=n(E),Ma=r(E,"P",{"data-svelte-h":!0}),m(Ma)!=="svelte-rosfou"&&(Ma.textContent=Cm),Wn=n(E),Pa=r(E,"P",{"data-svelte-h":!0}),m(Pa)!=="svelte-hlwvkn"&&(Pa.textContent=Am),Un=n(E),pe=r(E,"DIV",{class:!0});var uo=l(pe);c(pt.$$.fragment,uo),Qn=n(uo),qa=r(uo,"P",{"data-svelte-h":!0}),m(qa)!=="svelte-1gr03w4"&&(qa.textContent=Lm),uo.forEach(i),E.forEach(i),Hr=n(e),z=r(e,"DIV",{class:!0});var B=l(z);c(dt.$$.fragment,B),jn=n(B),ka=r(B,"P",{"data-svelte-h":!0}),m(ka)!=="svelte-1ss2c23"&&(ka.textContent=Tm),Kn=n(B),Ea=r(B,"P",{"data-svelte-h":!0}),m(Ea)!=="svelte-ewqetr"&&(Ea.innerHTML=zm),Zn=n(B),Na=r(B,"P",{"data-svelte-h":!0}),m(Na)!=="svelte-1q705lb"&&(Na.innerHTML=Dm),Xn=n(B),Oa=r(B,"P",{"data-svelte-h":!0}),m(Oa)!=="svelte-14ul3re"&&(Oa.innerHTML=Mm),Jn=n(B),de=r(B,"DIV",{class:!0});var fo=l(de);c(ct.$$.fragment,fo),Yn=n(fo),Ia=r(fo,"P",{"data-svelte-h":!0}),m(Ia)!=="svelte-1gr03w4"&&(Ia.textContent=Pm),fo.forEach(i),B.forEach(i),Br=n(e),k=r(e,"DIV",{class:!0});var j=l(k);c(gt.$$.fragment,j),ei=n(j),Fa=r(j,"P",{"data-svelte-h":!0}),m(Fa)!=="svelte-3mtxcr"&&(Fa.textContent=qm),ti=n(j),Ha=r(j,"P",{"data-svelte-h":!0}),m(Ha)!=="svelte-797qvx"&&(Ha.innerHTML=km),ai=n(j),Ba=r(j,"P",{"data-svelte-h":!0}),m(Ba)!=="svelte-1qa39gq"&&(Ba.innerHTML=Em),ri=n(j),ce=r(j,"DIV",{class:!0});var ho=l(ce);c(ut.$$.fragment,ho),oi=n(ho),Ra=r(ho,"P",{"data-svelte-h":!0}),m(Ra)!=="svelte-1gr03w4"&&(Ra.textContent=Nm),ho.forEach(i),j.forEach(i),Rr=n(e),W=r(e,"DIV",{class:!0});var ar=l(W);c(ft.$$.fragment,ar),ni=n(ar),Ga=r(ar,"P",{"data-svelte-h":!0}),m(Ga)!=="svelte-5vv99d"&&(Ga.textContent=Om),ii=n(ar),ge=r(ar,"DIV",{class:!0});var vo=l(ge);c(ht.$$.fragment,vo),mi=n(vo),Sa=r(vo,"P",{"data-svelte-h":!0}),m(Sa)!=="svelte-1gr03w4"&&(Sa.textContent=Im),vo.forEach(i),ar.forEach(i),Gr=n(e),vt=r(e,"DIV",{class:!0});var is=l(vt);c(bt.$$.fragment,is),is.forEach(i),Sr=n(e),y=r(e,"DIV",{class:!0});var M=l(y);c(_t.$$.fragment,M),si=n(M),Va=r(M,"P",{"data-svelte-h":!0}),m(Va)!=="svelte-1tqv0s5"&&(Va.textContent=Fm),li=n(M),Wa=r(M,"P",{"data-svelte-h":!0}),m(Wa)!=="svelte-g10xv4"&&(Wa.textContent=Hm),pi=n(M),Ua=r(M,"P",{"data-svelte-h":!0}),m(Ua)!=="svelte-1acg3vg"&&(Ua.textContent=Bm),di=n(M),Qa=r(M,"OL",{"data-svelte-h":!0}),m(Qa)!=="svelte-15y6o6y"&&(Qa.innerHTML=Rm),ci=n(M),ja=r(M,"P",{"data-svelte-h":!0}),m(ja)!=="svelte-1yvkj2h"&&(ja.innerHTML=Gm),gi=n(M),Ka=r(M,"P",{"data-svelte-h":!0}),m(Ka)!=="svelte-53x1ow"&&(Ka.innerHTML=Sm),ui=n(M),ue=r(M,"DIV",{class:!0});var bo=l(ue);c(xt.$$.fragment,bo),fi=n(bo),Za=r(bo,"P",{"data-svelte-h":!0}),m(Za)!=="svelte-1gr03w4"&&(Za.textContent=Vm),bo.forEach(i),M.forEach(i),Vr=n(e),yt=r(e,"DIV",{class:!0});var ms=l(yt);c($t.$$.fragment,ms),ms.forEach(i),Wr=n(e),X=r(e,"DIV",{class:!0});var _o=l(X);c(wt.$$.fragment,_o),hi=n(_o),fe=r(_o,"DIV",{class:!0});var xo=l(fe);c(Ct.$$.fragment,xo),vi=n(xo),Xa=r(xo,"P",{"data-svelte-h":!0}),m(Xa)!=="svelte-1gr03w4"&&(Xa.textContent=Wm),xo.forEach(i),_o.forEach(i),Ur=n(e),c(At.$$.fragment,e),Qr=n(e),hr=r(e,"P",{}),l(hr).forEach(i),this.h()},h(){v(Z,"name","hf:doc:metadata"),v(Z,"content",hs),v(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(Qe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(de,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(vt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(yt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,s){t(document.head,Z),p(e,vr,s),p(e,rr,s),p(e,br,s),g(ve,e,s),p(e,_r,s),p(e,be,s),p(e,xr,s),g(_e,e,s),p(e,yr,s),g(xe,e,s),p(e,$r,s),p(e,_,s),g(ye,_,null),t(_,yo),t(_,Lt),t(_,$o),t(_,Tt),t(_,wo),t(_,zt),t(_,Co),t(_,or),t(or,nr),t(nr,$e),g(we,$e,null),t($e,Ao),t($e,Dt),t(_,Lo),t(_,ir),t(ir,mr),t(mr,Ce),g(Ae,Ce,null),t(Ce,To),t(Ce,Mt),t(_,zo),t(_,sr),t(sr,lr),t(lr,Le),g(Te,Le,null),t(Le,Do),t(Le,Pt),t(_,Mo),t(_,pr),t(pr,dr),t(dr,ze),g(De,ze,null),t(ze,Po),t(ze,qt),t(_,qo),t(_,kt),t(_,ko),t(_,Et),p(e,wr,s),p(e,x,s),g(Me,x,null),t(x,Eo),t(x,Nt),t(x,No),t(x,Ot),t(x,Oo),t(x,It),t(x,Io),t(x,Ft),t(x,Fo),t(x,Ht),t(x,Ho),t(x,Bt),t(x,Bo),t(x,Rt),p(e,Cr,s),p(e,C,s),g(Pe,C,null),t(C,Ro),t(C,Gt),t(C,Go),t(C,St),t(C,So),t(C,Vt),t(C,Vo),t(C,cr),t(cr,gr),t(gr,qe),g(ke,qe,null),t(qe,Wo),t(qe,Wt),t(C,Uo),t(C,ur),t(ur,fr),t(fr,Ee),g(Ne,Ee,null),t(Ee,Qo),t(Ee,Ut),p(e,Ar,s),g(Oe,e,s),p(e,Lr,s),p(e,A,s),g(Ie,A,null),t(A,jo),t(A,Qt),t(A,Ko),t(A,jt),t(A,Zo),t(A,Kt),t(A,Xo),t(A,Zt),t(A,Jo),t(A,J),g(Fe,J,null),t(J,Yo),t(J,Xt),p(e,Tr,s),p(e,L,s),g(He,L,null),t(L,en),t(L,Jt),t(L,tn),t(L,Yt),t(L,an),t(L,ea),t(L,rn),t(L,ta),t(L,on),t(L,Y),g(Be,Y,null),t(Y,nn),t(Y,aa),p(e,zr,s),p(e,R,s),g(Re,R,null),t(R,mn),t(R,ra),t(R,sn),t(R,oa),p(e,Dr,s),p(e,T,s),g(Ge,T,null),t(T,ln),t(T,na),t(T,pn),t(T,ee),g(Se,ee,null),t(ee,dn),t(ee,ia),t(T,cn),t(T,te),g(Ve,te,null),t(te,gn),t(te,ma),t(T,un),t(T,ae),g(We,ae,null),t(ae,fn),t(ae,sa),t(T,hn),t(T,re),g(Ue,re,null),t(re,vn),t(re,la),p(e,Mr,s),p(e,Qe,s),g(je,Qe,null),p(e,Pr,s),p(e,P,s),g(Ke,P,null),t(P,bn),t(P,pa),t(P,_n),t(P,da),t(P,xn),t(P,ca),t(P,yn),t(P,oe),g(Ze,oe,null),t(oe,$n),t(oe,ga),p(e,qr,s),p(e,G,s),g(Xe,G,null),t(G,wn),t(G,ua),t(G,Cn),t(G,ne),g(Je,ne,null),t(ne,An),t(ne,fa),p(e,kr,s),p(e,S,s),g(Ye,S,null),t(S,Ln),t(S,ha),t(S,Tn),t(S,ie),g(et,ie,null),t(ie,zn),t(ie,va),p(e,Er,s),p(e,q,s),g(tt,q,null),t(q,Dn),t(q,ba),t(q,Mn),t(q,_a),t(q,Pn),t(q,xa),t(q,qn),t(q,me),g(at,me,null),t(me,kn),t(me,ya),p(e,Nr,s),p(e,N,s),g(rt,N,null),t(N,En),t(N,$a),t(N,Nn),t(N,wa),t(N,On),t(N,se),g(ot,se,null),t(se,In),t(se,Ca),p(e,Or,s),p(e,V,s),g(nt,V,null),t(V,Fn),t(V,Aa),t(V,Hn),t(V,le),g(it,le,null),t(le,Bn),t(le,La),p(e,Ir,s),p(e,mt,s),g(st,mt,null),p(e,Fr,s),p(e,w,s),g(lt,w,null),t(w,Rn),t(w,Ta),t(w,Gn),t(w,za),t(w,Sn),t(w,Da),t(w,Vn),t(w,Ma),t(w,Wn),t(w,Pa),t(w,Un),t(w,pe),g(pt,pe,null),t(pe,Qn),t(pe,qa),p(e,Hr,s),p(e,z,s),g(dt,z,null),t(z,jn),t(z,ka),t(z,Kn),t(z,Ea),t(z,Zn),t(z,Na),t(z,Xn),t(z,Oa),t(z,Jn),t(z,de),g(ct,de,null),t(de,Yn),t(de,Ia),p(e,Br,s),p(e,k,s),g(gt,k,null),t(k,ei),t(k,Fa),t(k,ti),t(k,Ha),t(k,ai),t(k,Ba),t(k,ri),t(k,ce),g(ut,ce,null),t(ce,oi),t(ce,Ra),p(e,Rr,s),p(e,W,s),g(ft,W,null),t(W,ni),t(W,Ga),t(W,ii),t(W,ge),g(ht,ge,null),t(ge,mi),t(ge,Sa),p(e,Gr,s),p(e,vt,s),g(bt,vt,null),p(e,Sr,s),p(e,y,s),g(_t,y,null),t(y,si),t(y,Va),t(y,li),t(y,Wa),t(y,pi),t(y,Ua),t(y,di),t(y,Qa),t(y,ci),t(y,ja),t(y,gi),t(y,Ka),t(y,ui),t(y,ue),g(xt,ue,null),t(ue,fi),t(ue,Za),p(e,Vr,s),p(e,yt,s),g($t,yt,null),p(e,Wr,s),p(e,X,s),g(wt,X,null),t(X,hi),t(X,fe),g(Ct,fe,null),t(fe,vi),t(fe,Xa),p(e,Ur,s),g(At,e,s),p(e,Qr,s),p(e,hr,s),jr=!0},p:ls,i(e){jr||(u(ve.$$.fragment,e),u(_e.$$.fragment,e),u(xe.$$.fragment,e),u(ye.$$.fragment,e),u(we.$$.fragment,e),u(Ae.$$.fragment,e),u(Te.$$.fragment,e),u(De.$$.fragment,e),u(Me.$$.fragment,e),u(Pe.$$.fragment,e),u(ke.$$.fragment,e),u(Ne.$$.fragment,e),u(Oe.$$.fragment,e),u(Ie.$$.fragment,e),u(Fe.$$.fragment,e),u(He.$$.fragment,e),u(Be.$$.fragment,e),u(Re.$$.fragment,e),u(Ge.$$.fragment,e),u(Se.$$.fragment,e),u(Ve.$$.fragment,e),u(We.$$.fragment,e),u(Ue.$$.fragment,e),u(je.$$.fragment,e),u(Ke.$$.fragment,e),u(Ze.$$.fragment,e),u(Xe.$$.fragment,e),u(Je.$$.fragment,e),u(Ye.$$.fragment,e),u(et.$$.fragment,e),u(tt.$$.fragment,e),u(at.$$.fragment,e),u(rt.$$.fragment,e),u(ot.$$.fragment,e),u(nt.$$.fragment,e),u(it.$$.fragment,e),u(st.$$.fragment,e),u(lt.$$.fragment,e),u(pt.$$.fragment,e),u(dt.$$.fragment,e),u(ct.$$.fragment,e),u(gt.$$.fragment,e),u(ut.$$.fragment,e),u(ft.$$.fragment,e),u(ht.$$.fragment,e),u(bt.$$.fragment,e),u(_t.$$.fragment,e),u(xt.$$.fragment,e),u($t.$$.fragment,e),u(wt.$$.fragment,e),u(Ct.$$.fragment,e),u(At.$$.fragment,e),jr=!0)},o(e){f(ve.$$.fragment,e),f(_e.$$.fragment,e),f(xe.$$.fragment,e),f(ye.$$.fragment,e),f(we.$$.fragment,e),f(Ae.$$.fragment,e),f(Te.$$.fragment,e),f(De.$$.fragment,e),f(Me.$$.fragment,e),f(Pe.$$.fragment,e),f(ke.$$.fragment,e),f(Ne.$$.fragment,e),f(Oe.$$.fragment,e),f(Ie.$$.fragment,e),f(Fe.$$.fragment,e),f(He.$$.fragment,e),f(Be.$$.fragment,e),f(Re.$$.fragment,e),f(Ge.$$.fragment,e),f(Se.$$.fragment,e),f(Ve.$$.fragment,e),f(We.$$.fragment,e),f(Ue.$$.fragment,e),f(je.$$.fragment,e),f(Ke.$$.fragment,e),f(Ze.$$.fragment,e),f(Xe.$$.fragment,e),f(Je.$$.fragment,e),f(Ye.$$.fragment,e),f(et.$$.fragment,e),f(tt.$$.fragment,e),f(at.$$.fragment,e),f(rt.$$.fragment,e),f(ot.$$.fragment,e),f(nt.$$.fragment,e),f(it.$$.fragment,e),f(st.$$.fragment,e),f(lt.$$.fragment,e),f(pt.$$.fragment,e),f(dt.$$.fragment,e),f(ct.$$.fragment,e),f(gt.$$.fragment,e),f(ut.$$.fragment,e),f(ft.$$.fragment,e),f(ht.$$.fragment,e),f(bt.$$.fragment,e),f(_t.$$.fragment,e),f(xt.$$.fragment,e),f($t.$$.fragment,e),f(wt.$$.fragment,e),f(Ct.$$.fragment,e),f(At.$$.fragment,e),jr=!1},d(e){e&&(i(vr),i(rr),i(br),i(_r),i(be),i(xr),i(yr),i($r),i(_),i(wr),i(x),i(Cr),i(C),i(Ar),i(Lr),i(A),i(Tr),i(L),i(zr),i(R),i(Dr),i(T),i(Mr),i(Qe),i(Pr),i(P),i(qr),i(G),i(kr),i(S),i(Er),i(q),i(Nr),i(N),i(Or),i(V),i(Ir),i(mt),i(Fr),i(w),i(Hr),i(z),i(Br),i(k),i(Rr),i(W),i(Gr),i(vt),i(Sr),i(y),i(Vr),i(yt),i(Wr),i(X),i(Ur),i(Qr),i(hr)),i(Z),h(ve,e),h(_e,e),h(xe,e),h(ye),h(we),h(Ae),h(Te),h(De),h(Me),h(Pe),h(ke),h(Ne),h(Oe,e),h(Ie),h(Fe),h(He),h(Be),h(Re),h(Ge),h(Se),h(Ve),h(We),h(Ue),h(je),h(Ke),h(Ze),h(Xe),h(Je),h(Ye),h(et),h(tt),h(at),h(rt),h(ot),h(nt),h(it),h(st),h(lt),h(pt),h(dt),h(ct),h(gt),h(ut),h(ft),h(ht),h(bt),h(_t),h(xt),h($t),h(wt),h(Ct),h(At,e)}}}const hs='{"title":"Optimization","local":"optimization","sections":[{"title":"Optimizers","local":"optimizers","sections":[{"title":"Factory functions","local":"timm.optim.create_optimizer_v2","sections":[],"depth":3}],"depth":2}],"depth":1}';function vs(bi){return ps(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class $s extends ds{constructor(Z){super(),cs(this,Z,vs,fs,ss,{})}}export{$s as component};
